//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "urepldragdrop.h"
#include "SDL_filesys.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SDL_replist"
#pragma resource "*.dfm"
TForm1 *Form1;



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BButExitClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RLMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
if ( Shift.Contains(ssLeft) && (Y > dynamic_cast <TReportListView*>(Sender)->DefaultRowHeight) &&
   (dynamic_cast <TReportListView*>(Sender)->NrOfRows > 0))
  {
  dynamic_cast <TReportListView*>(Sender)->BeginDrag (false, 20);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
const AnsiString FirstNames[6] = {"Claire", "John", "Patty", "Woody", "Jim", "Barbara"};
const AnsiString LastNames[5] = {"Smith","Mailer","Henderson","Illiadus","Mayer"};

TNameStrType Hdr[2] = {"Name", "Password"};

int i;

RLLeft->InterRowIndicatorColor = clBlue;
for (i=1; i<=2; i++)
  {
  RLLeft->Header[i] = Hdr[i-1];
  RLRight->Header[i] = Hdr[i-1];
  }
randomize();
for (i=1; i<=RLLeft->NrOfRows; i++)
  {
  RLLeft->Elem[1][i] = FirstNames[random(6)]+" "+LastNames[1+random(5)];
  RLLeft->Elem[2][i] = UTF8EncodeToShortString(InventPassword(8));
  };
for (i=1; i<=RLRight->NrOfRows; i++)
  {
  RLRight->Elem[1][i] = FirstNames[random(6)]+" "+LastNames[1+random(5)];
  RLRight->Elem[2][i] = UTF8EncodeToShortString(InventPassword(8));
  };
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RLDragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
TGridCoord GridCell;

Accept = false;
if (Source->ClassNameIs("TReportListView"))
  {
  if (Source!=Sender)
    {
    TReportListView *RLSender = dynamic_cast<TReportListView*>(Sender);
    GridCell = RLSender->MouseCoord(X, Y-RLSender->DefaultRowHeight/2);
    RLSender->InterRowIndicatorPos = GridCell.Y+1;
    Accept = true;
    };
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RLDragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
int  i;
int  destrow;
int  NRow;
TReportListView *RLSender;
TReportListView *RLSource;

if (Source->ClassNameIs("TReportListView"))
  {
//  if (Source!=Sender)
    {
    RLSender = static_cast<TReportListView*>(Sender);
    RLSource = static_cast<TReportListView*>(Source);

    RLSource->SuppressPaint = true;
    RLSender->SuppressPaint = true;
    destrow = RLSender->InterRowIndicatorPos;
    NRow = RLSource->NrOfRows;
    for (i=NRow; i>=1; i--)
      {
      if (RLSource->RowSelected[i])
        {
        destrow = RLSender->InsertRow (destrow);
        RLSender->Elem[1][destrow] = RLSource->Elem[1][i];
        RLSender->Elem[2][destrow] = RLSource->Elem[2][i];
        RLSource->InterRowIndicatorPos = 0;
        RLSender->InterRowIndicatorPos = 0;
        RLSource->RemoveRow (i);
        };
      };
    RLSource->SuppressPaint = false;
    RLSender->SuppressPaint = false;
    Invalidate();
    };
  };
}
//---------------------------------------------------------------------------

